//============================================================================
// qtXLS.h  -  Header file for qtXLS
//----------------------------------------------------------------------------
#ifndef _QTXLS_
#define _QTXLS_

#ifndef  _WINDOWS_
#include <windows.h>
#endif

/// MODULE qtXLSDeclarations

// Constants
const long	qt_I_MaxPathLEN = 1024;
const long  qt_I_MaxTableNameLEN	= 20480;
const long	qt_I_MaxColumneNameLEN = 64;
const long  qt_I_MaxStatementLEN	= 20480;		// qt_I_MAXTABLENAMELEN + 255 * (64 + 8 + 3) + 18 ca. 20000: max. 255 columns, max. 64 characters per column, max. 8 characters per type, 3 delimiters
const long  qt_I_SQLDataTypeLEN = 42;			// max. length of SQL Data Type names like VARCHAR, NUMBER etc.

// KINDs
typedef	char		qt_K_INT1;
typedef	short		qt_K_INT2;
typedef	long		qt_K_INT4;
typedef	float		qt_K_R4;
typedef	double	qt_K_R8;

typedef	long	qt_K_LP;

typedef	short		qt_K_SMALLINT;
typedef	long		qt_K_UINTEGER;
typedef	long		qt_K_INTEGER;
typedef	long		qt_K_HANDLE;
typedef	short		qt_K_RETURN;

typedef char type_charTableNamesRecord[qt_I_MaxTableNameLEN];

#define	qt_SQL_CHAR   1
#define  qt_SQL_NUMERIC   2
#define  qt_SQL_DECIMAL   3
#define  qt_SQL_INTEGER   4
#define  qt_SQL_SMALLINT   5
#define  qt_SQL_FLOAT   6
#define  qt_SQL_REAL   7
#define  qt_SQL_DOUBLE   8
#define  qt_SQL_DATETIME   9
#define  qt_SQL_VARCHAR   12,
#define  qt_SQL_TYPE_DATE   91
#define  qt_SQL_TYPE_TIME   92
#define  qt_SQL_TYPE_TIMESTAMP   93,
#define  qt_SQL_DATE   9
#define  qt_SQL_INTERVAL   10
#define  qt_SQL_TIME   10
#define  qt_SQL_TIMESTAMP   11
#define  qt_SQL_LONGVARCHAR   -1
#define  qt_SQL_BINARY   -2
#define  qt_SQL_VARBINARY   -3
#define  qt_SQL_LONGVARBINARY   -4,
#define  qt_SQL_BIGINT   -5
#define  qt_SQL_TINYINT   -6
#define  qt_SQL_BIT   -7
#define  qt_SQL_GUID   -11

#define  qt_SQL_C_CHAR   qt_SQL_CHAR
#define  qt_SQL_C_LONG   qt_SQL_INTEGER
#define  qt_SQL_C_SHORT   qt_SQL_SMALLINT
#define  qt_SQL_C_FLOAT   qt_SQL_REAL
#define  qt_SQL_C_DOUBLE   qt_SQL_DOUBLE
#define  qt_SQL_C_NUMERIC   qt_SQL_NUMERIC
#define  qt_SQL_C_DEFAULT   99
#define  qt_SQL_SIGNED_OFFSET   -20
#define  qt_SQL_UNSIGNED_OFFSET   -22
#define  qt_SQL_C_DATE   qt_SQL_DATE
#define  qt_SQL_C_TIME   qt_SQL_TIME
#define  qt_SQL_C_TIMESTAMP   qt_SQL_TIMESTAMP
#define  qt_SQL_C_TYPE_DATE   qt_SQL_TYPE_DATE
#define  qt_SQL_C_TYPE_TIME   qt_SQL_TYPE_TIME
#define  qt_SQL_C_TYPE_TIMESTAMP   qt_SQL_TYPE_TIMESTAMP
#define  qt_SQL_C_BINARY   qt_SQL_BINARY
#define  qt_SQL_C_BIT   qt_SQL_BIT
#define  qt_SQL_C_SBIGINT   (qt_SQL_BIGINT+qt_SQL_SIGNED_OFFSET)
#define  qt_SQL_C_UBIGINT   (qt_SQL_BIGINT+qt_SQL_UNSIGNED_OFFSET)
#define  qt_SQL_C_TINYINT   qt_SQL_TINYINT
#define  qt_SQL_C_SLONG   (qt_SQL_C_LONG+qt_SQL_SIGNED_OFFSET)
#define  qt_SQL_C_SSHORT   (qt_SQL_C_SHORT+qt_SQL_SIGNED_OFFSET)
#define  qt_SQL_C_STINYINT   (qt_SQL_TINYINT+qt_SQL_SIGNED_OFFSET)
#define  qt_SQL_C_ULONG   (qt_SQL_C_LONG+qt_SQL_UNSIGNED_OFFSET)
#define  qt_SQL_C_USHORT   (qt_SQL_C_SHORT+qt_SQL_UNSIGNED_OFFSET)
#define  qt_SQL_C_UTINYINT   (qt_SQL_TINYINT+qt_SQL_UNSIGNED_OFFSET)
#define  qt_SQL_C_BOOKMARK   qt_SQL_C_ULONG
#define  qt_SQL_C_GUID   qt_SQL_GUID
#define  qt_SQL_TYPE_NULL   0
#define  qt_SQL_TYPE_MIN   qt_SQL_BIT
#define  qt_SQL_TYPE_MAX   qt_SQL_VARCHAR
#define  qt_SQL_C_VARBOOKMARK   qt_SQL_C_BINARY
#define  qt_SQL_NO_ROW_NUMBER   -1
#define  qt_SQL_NO_COLUMN_NUMBER   -1
#define  qt_SQL_ROW_NUMBER_UNKNOWN   -2
#define  qt_SQL_COLUMN_NUMBER_UNKNOWN   -2

// Error codes
const int  qtERRORBase  = 70000;
const int  qtERRORNotZeroTerminated		 = qtERRORBase + 1;
const int  qtERRORAllocHandleFailed		 = qtERRORBase + 2;
const int  qtERRORSQLFunctionFailed		 =  qtERRORBase + 3;
const int  qtERRORConnectFailed			 =  qtERRORBase + 4;
const int  qtERRORInsufficientDimension = qtERRORBase + 5;
const int  qtERRORNameNotSpecified		 = qtERRORBase + 6;
const int  qtERRORInvalid					 = qtERRORBase + 7;
const int  qtERRORExecDirectFailed		 = qtERRORBase + 8;
const int  qtERRORInsufficientSize		 = qtERRORBase + 9;
const int  qtERRORNotSupported			 = qtERRORBase + 10;
// const int  qtERRORBase + 1;

const int  qtERRORUnknown					 = qtERRORBase + 200;		// the last error code

// STRUCTURES
struct qT_ColumnInfo {
	char			szName[qt_I_MaxColumneNameLEN];	// column name (zero terminated)
	qt_K_INT2	SQLDataType;							// ODBC SQL data type (e.g. qt_SQL_TYPE_DATE or qt_SQL_INTERVAL_YEAR_TO_MONTH
	char			TypeName[qt_I_SQLDataTypeLEN];	// column type name (datasource dependent; for example, CHAR, VARCHAR, MONEY, LONG VARBINAR, or CHAR ( ) FOR BIT DATA.
	qt_K_INT4	MaxLen;									// IF SQLDataType =  qt_SQL_CHAR or qt_SQL_VARCHAR, the maximum length in characters of the column is returned. For datetime data types, this is the total number of characters required to display the value when converted to characters. For numeric data types, this is either the total number of digits or the total number of bits allowed in the column, according to the NUM_PREC_RADIX column. For interval data types, this is the number of characters in the character representation of the interval literal (as defined by the interval leading precision, see Interval Data Type Length in Appendix D, Data Types). For more information, see Column Size, Decimal Digits, Transfer Octet Length, and Display Size in Appendix D, Data Types.
	// mehr evt. spter (vgl. SDK: SQLColumns)
};

struct qT_SQLColumn {
	char			Name[qt_I_MaxColumneNameLEN ];			// column name (either zero terminated or blank padded)
	qt_K_LP		ArrayAddr;	// LOC(array for results)
	qt_K_INT4	ArrayDim;		// ArrayDimension 
	qt_K_INT4	ArrayType;	// type of array (qt_SQL_C_...: qt_SQL_C_SSHORT, qt_SQL_C_SLONG, qt_SQL_C_DOUBLE, qt_SQL_C_FLOAT, qt_SQL_C_CHAR, qt_SQL_C_DATE, qt_SQL_C_BIT ...). This usually also determines the length of a single array element (in bytes), but not for strings
	qt_K_INT4	LENArrElem;	// length of single array element in characters in case of string arrays
	qt_K_LP		IndArrAddr;	// now: not used, should be 0; later: LOC() of result indicator array (result   qt_SQL_NULL_DATA (=-1) or valid value (=0)) or length of result (>0))
};

struct qT_DATE_STRUCT {
	qt_K_SMALLINT	year;
	qt_K_SMALLINT	month;
	qt_K_SMALLINT	day;
};

struct qT_TIME_STRUCT {
	qt_K_SMALLINT	hour;
	qt_K_SMALLINT	minute;
	qt_K_SMALLINT	second;
};

struct qT_TIMESTAMP_STRUCT {
	qt_K_SMALLINT	year;
	qt_K_SMALLINT	month;
	qt_K_SMALLINT	day;
	qt_K_SMALLINT	hour;
	qt_K_SMALLINT	minute;
	qt_K_SMALLINT	second;
	qt_K_UINTEGER	fraction;
};

#define qt_SQL_MAX_NUMERIC_LEN   16

struct qT_NUMERIC_STRUCT {
	qt_K_INT1	precision;							// The precision and scale fields of the qt_SQL_C_NUMERIC data type are never used for input from an application, only for output from the driver to the application. When the driver writes a numeric value into the qt_SQL_NUMERIC_STRUCT, it will use its own driver-specific default as the value for the precision field, 		
	qt_K_INT1	scale;									// and it will use the value in the qt_SQL_DESC_SCALE field of the application descriptor (which defaults to 0) for the scale field. An application can provide its own values for precision and scale by setting the qt_SQL_DESC_PRECISION and qt_SQL_DESC_SCALE fields of the application descriptor.
	qt_K_INT1	sign;									// 1 if positive, 0 if negative
	qt_K_INT1	val[qt_SQL_MAX_NUMERIC_LEN];	// A number is stored in the val field of the qt_SQL_NUMERIC_STRUCT structure as a scaled integer, in little endian mode (the leftmost byte being the least-significant byte). For example, the number 10.001 base 10, with a scale of 4, is scaled to an integer of 100010. Because this is 186AA in hexadecimal format, the value in qt_SQL_NUMERIC_STRUCT would be "AA 86 01 00 00 ... 00", with the number of bytes defined by the qt_SQL_MAX_NUMERIC_LEN #define (=16).
};

//-----------------------------------------------------------------------------

// qtXLS PROTOTYPES / IMPORTED ROUTINES
/* Declare the routines imported from the qtXLS.dll.
   The "C" attribute prevents C++ name mangling  Remove it
   if the file type is .c
*/
#ifdef __cplusplus
extern "C" 
#endif
{

#define qtXLSCreateEXCELFile  qtXLScr
qt_K_HANDLE WINAPI qtXLSCreateEXCELFile( LPSTR szFileName );

#define qtXLSOpenEXCELFile  qtXLSop
qt_K_HANDLE WINAPI qtXLSOpenEXCELFile( LPSTR szFileName );

#define qtXLSCloseEXCELFile  qtXLScl
qt_K_INTEGER WINAPI qtXLSCloseEXCELFile( qt_K_HANDLE hDS );

#define qtXLSCreateTable  qtXLSct
qt_K_INTEGER WINAPI qtXLSCreateTable( qt_K_HANDLE hDS, 
												  LPSTR szTableDefinition  );

#define qtXLSGetTableNames  qtXLStn
VOID WINAPI qtXLSGetTableNames( qt_K_HANDLE hDS, 
										  qt_K_INT4 iDIMcTableNames, 
										  //char *cTableNames[][qt_I_MaxTableNameLEN], 
										  //char *type_charTableNamesRecord[], 
										  char *cTableNames, 
										  qt_K_INT4 *iCountTableNames, 
										  qt_K_INT4 *iError );

#define qtXLSGetColumnInfo  qtXLSci
VOID WINAPI qtXLSGetColumnInfo( qt_K_HANDLE hDS, 
										  LPSTR szTableName, 
										  qt_K_INT4 iDIMColumnInfo,
										  qT_ColumnInfo *ColumnInfo,
										  qt_K_INT4 *iCountColumnInfo,
										  qt_K_INT4 *iError );

#define qtXLSGetRowCount  qtXLSrc
qt_K_INTEGER WINAPI qtXLSGetRowCount( qt_K_HANDLE hDS, 
												  LPSTR szTableName );

#define qtXLSReadRows  qtXLSrr
qt_K_INTEGER WINAPI qtXLSReadRows( qt_K_HANDLE hDS, 
											  LPSTR szTableName,						
											  qt_K_INTEGER iNoColums,
											  qt_K_INTEGER iNoRows,					
											  qT_SQLColumn *tColumns, 
											  LPSTR szCondition, 
											  LPSTR szOrderBy);

#define qtXLSWriteRows  qtXLSwr
qt_K_INTEGER WINAPI qtXLSWriteRows( qt_K_HANDLE hDS, 
											   LPSTR szTableName, 
											   qt_K_INTEGER iNoColums, 
											   qt_K_INTEGER iNoRows, 
											   qT_SQLColumn *tColumns );

#define qtXLSGetErrorMessages  qtXLSem
qt_K_INTEGER WINAPI qtXLSGetErrorMessages( LPSTR szErrorMessages, 
														 qt_K_INTEGER iBufSizeErrorMessages );

#define qtXLSSetErrorLevel  qtXLSel
VOID WINAPI qtXLSSetErrorLevel( qt_K_INTEGER iErrorLevel  );

#define qtXLSCheckSQLReturnCode  qtXLScs
VOID WINAPI qtXLSCheckSQLReturnCode( qt_K_HANDLE hDS, 
												 qt_K_HANDLE hBef, 
												 qt_K_RETURN iSQLRetCode );

#define qtXLSSetErrorMessagesDisplay  qtXLSmd
VOID WINAPI qtXLSSetErrorMessagesDisplay( qt_K_INTEGER iDisplayErrorMessages );

#define qtXLSGetNumericValue  qtXLSnv
qt_K_R8 WINAPI qtXLSGetNumericValue( qT_NUMERIC_STRUCT *NMVal );

#define qtXLSDoesTableNameExist  qtXLStx
qt_K_INTEGER WINAPI qtXLSDoesTableNameExist( qt_K_HANDLE hDS, LPSTR szTableName );

#define qtXLSSetLicencePath  qtXLSlp
VOID WINAPI qtXLSSetLicencePath( LPSTR szPathName );

#define qtXLSGetszStringLength  qtXLSsl
qt_K_INTEGER WINAPI qtXLSGetszStringLength( LPSTR szString );
}
#endif // _QTXLS_
//----------------------------------------------------------------------------
// (C) Copyright QT software GmbH, Munich, Germany, 2003. All rights reserved.
//============================================================================
