#include <stdio.h>
#include <qtXLS.h>

int main(void)
{
	char *szFileName;
	qt_K_HANDLE hDS;
	qt_K_INT4 iDIMcTableNames;
	char *cTableNames, *cTableNamesInd;		// -> string array with elements of length qt_I_MaxTableNameLEN
	char *szTableDefinition;
	qt_K_INT4 iCountTableNames, iError;
	qt_K_INTEGER iRet, ind, iLen, jLen, indCol, iDIMColumnInfo, iCountColumnInfo;
	qT_ColumnInfo *ColumnInfo;


	// qtSetXLSLicencePath( szPathName )		// change the path to a location where the licence file resides

// Test "Open"
	szFileName = "qtXLSDemo2.xls";
	hDS = qtXLSOpenEXCELFile( szFileName );
	if ( hDS == 0 )	
	{
		printf("Error, qtXLSOpenEXCELFile = %d\n", hDS);
		printf("\n");
		printf("Create file (calling qtXLSCreateEXCELFile).\n");
		hDS = qtXLSCreateEXCELFile( szFileName ); 
		if ( hDS == 0 )
			printf("Error, qtXLSCreateEXCELFile = %d\n", hDS);
		else
		{
		printf("qtXLSCreateEXCELFile creates %s\n", szFileName);
		//printf("qtXLSCreateEXCELFile = %d\n", hDS);
		}
	}

	printf("Test 'Create Table'\n");
	printf("-------------------\n");
// Test "Create Table"
	szTableDefinition = "Coordinates (x NUMBER, y NUMBER, z NUMBER, t DATETIME, Comment TEXT)";
	iRet = qtXLSCreateTable( hDS, szTableDefinition );
	if ( iRet == 0 )
	{
		iLen = qtXLSGetszStringLength( szTableDefinition );
		printf("qtXLSCreateTable successfull; Table '%s ' created.\n",
				 szTableDefinition);
	}
	else
		printf("Error, qtXLSCreateTable = %d\n", iRet);

	printf("\n");
	printf("File info\n");
	printf("---------\n");
	iDIMcTableNames = 1;	// at least one, because qtXLSGetTableNames(...) requires an existing variable cTableNames
	cTableNames = ((char *) calloc(iDIMcTableNames, qt_I_MaxTableNameLEN));

M100:	
	qtXLSGetTableNames( hDS, iDIMcTableNames, 
						     cTableNames, 
						     &iCountTableNames, 
						     &iError );
	switch (iError)
	{
		case qtERRORInsufficientDimension :
			free(cTableNames);	// free insufficient array
			if ( iCountTableNames == 0 )
				printf("No tables could be found.\n");
			else
			{ // create string array cTableNames (each element holds a string up to [qt_I_MaxTableNameLEN] characters)
				iDIMcTableNames = iCountTableNames;
				cTableNames = ((char *) calloc(iDIMcTableNames, qt_I_MaxTableNameLEN));
				goto M100;
			}
			break;

		case 0 :
			printf("   Table names (and column names):\n");
			for ( ind = 0; ind < iCountTableNames; ind++)
			{
				cTableNamesInd = cTableNames + ind * qt_I_MaxTableNameLEN;
				iLen = qtXLSGetszStringLength( cTableNamesInd );
				printf("      %s\n", cTableNamesInd);

				iRet = qtXLSGetRowCount( hDS, cTableNamesInd );
				if ( iRet < 0 )
					printf("         Error calling qtXLSGetRowCount(...)\n");
				else
					printf("         Count rows: %d\n", iRet);

				// column names
				indCol = -1;
				iCountColumnInfo = 0;
				iDIMColumnInfo = 1;		// at least one, because qtXLSGetColumnInfo(...) requires an existing variable qT_ColumnInfo
				while ( indCol < iCountColumnInfo )
				{
					ColumnInfo = new qT_ColumnInfo[iDIMColumnInfo];
					qtXLSGetColumnInfo( hDS, 
											  cTableNamesInd, 
											  iDIMColumnInfo, 
											  ColumnInfo, 
											  &iCountColumnInfo, 
											  &iError );
				
					if ( iError == qtERRORInsufficientDimension )
					{
						delete ColumnInfo;
						iDIMColumnInfo = iCountColumnInfo;
						ColumnInfo = new qT_ColumnInfo[iDIMColumnInfo];
					}
					else if ( iError != 0 )
					{
						printf("   Error (qtXLSGetColumnInfo), iError = %d\n", iError);
						break;
					}
					if ( indCol >= 0 )
					{
						iLen = qtXLSGetszStringLength( ColumnInfo[indCol].szName );
						jLen = qtXLSGetszStringLength( ColumnInfo[indCol].TypeName );
						printf("         %s   %d   %s   %d\n", 
									ColumnInfo[indCol].szName,
									ColumnInfo[indCol].SQLDataType, 	
									ColumnInfo[indCol].TypeName,	
									ColumnInfo[indCol].MaxLen);								
					}
					indCol = indCol + 1;
				} // while ( indCol < iCountColumnInfo ) 
				delete ColumnInfo;
			} // 	for ( ind = 0; ind < iCountTableNames; ind++)
			delete cTableNames;
			break;

		default: 
			printf("   Error (qtXLSGetTableNames), iError = %d\n", iError);
			break;
	} // switch (iError)

	printf("\n");
	iRet = qtXLSCloseEXCELFile( hDS );
	if ( iRet == 0 )
		printf("qtXLS has been closed successfully.\n");
	else
		printf("Error, qtXLSCloseEXCELFile = %d\n", iRet);

	printf("\n");
	printf("(C) QT software GmbH, Munich, Germany. All rights reserved. 2003.\n");
	printf("    http:\\www.qtsoftware.de    eMail: info@qtsoftware.de\n");
	return 0;
}
