PROGRAM qtXLSDemoCreateTable
	USE qtXLS
	IMPLICIT NONE

	CHARACTER (30) szFileName
	INTEGER (qt_K_HANDLE) hDS
	INTEGER (qt_K_INT4) iDIMcTableNames
	CHARACTER (qt_I_MaxTableNameLEN), ALLOCATABLE :: cTableNames(:)
	CHARACTER (100) szTableDefinition
	INTEGER (qt_K_INT4) iCountTableNames, iError
	INTEGER iRet, ind, iLen, jLen, indCol, iDIMColumnInfo, iCountColumnInfo
	TYPE(qT_ColumnInfo), ALLOCATABLE :: ColumnInfo(:)

   ! prior usage of any other qtXLS function either provide the licence 
   ! file ( (L0611-######.lic, supplied with ealier versions of qtXLS)
   ! or call qtSetLicence_qtXLS(). Otherwise qtXLS runs in demo mode only.)
   !
   ! (1) in case of usage of the licence file (L0611-######.lic), you 
   !     might want to set the path such that the licence file can be found
   ! CALL qtSetXLSLicencePath( szPathName )	! change the path to a location where the licence file resides
   !
   ! (2) if you prefer to have the licence linked into your program
   !     call this routine
   CALL qtSetLicence_qtXLS( iError )    ! supplied in source form (file name: qtSetLicence_0611_######.f90)

! Test "Open"
	szFileName = 'qtXLSDemo2.xls' // CHAR(0)
	hDS = qtXLSOpenEXCELFile( szFileName )
	IF ( hDS == 0 ) THEN
		PRINT*, 'Error, qtXLSOpenEXCELFile =', hDS
		PRINT*
		PRINT*, 'Create file (calling qtXLSCreateEXCELFile).'
		hDS = qtXLSCreateEXCELFile( szFileName )
		IF ( hDS == 0 ) THEN
			PRINT*, 'Error, qtXLSCreateEXCELFile =', hDS
			STOP
		ELSE
			PRINT*, 'qtXLSCreateEXCELFile creates ', szFileName
			!PRINT*, 'qtXLSCreateEXCELFile =', hDS
		END IF
	END IF

	PRINT*, 'Test "Create Table"'
	PRINT*, '-------------------'
! Test "Create Table"
	szTableDefinition = 'Coordinates (x NUMBER, y NUMBER, z NUMBER, t DATETIME, Comment TEXT)' // CHAR(0)
	iRet = qtXLSCreateTable( hDS, szTableDefinition )
	IF ( iRet == 0 ) THEN
		iLen = qtXLSGetszStringLength( szTableDefinition )
		PRINT*, 'qtXLSCreateTable successfull; Table "', szTableDefinition(1:iLen), '" created.'
	ELSE
		PRINT*, 'Error, qtXLSCreateTable =', iRet
	END IF

	PRINT*
	PRINT*, 'File info'
	PRINT*, '---------'
	iDIMcTableNames = 0
100	CONTINUE
	CALL qtXLSGetTableNames( hDS, iDIMcTableNames, cTableNames, iCountTableNames, iError )
	IF ( iError == 0 ) THEN
		PRINT*, '   Table names (and column names):'
		DO ind = 1, iCountTableNames
			iLen = qtXLSGetszStringLength(cTableNames(ind))
			PRINT*, '      ', cTableNames(ind)(1:iLen)

			iRet = qtXLSGetRowCount( hDS, cTableNames(ind) )
			IF ( iRet < 0 ) THEN
				PRINT*, '         Error calling qtXLSGetRowCount(...)'
			ELSE
            PRINT*, '         Count rows:', iRet
			END IF
			! column names
			indCol = -1
			iCountColumnInfo = 0
			iDIMColumnInfo = 0
			DO WHILE ( indCol < iCountColumnInfo ) 
            CALL qtXLSGetColumnInfo( hDS, cTableNames(ind), iDIMColumnInfo, ColumnInfo, iCountColumnInfo, iError )
				IF ( iError == qtERRORInsufficientDimension ) THEN
					iDIMColumnInfo = iCountColumnInfo
					ALLOCATE(ColumnInfo(iDIMColumnInfo))
				ELSE IF ( iError /= 0 ) THEN
					PRINT*, '   Error (qtXLSGetColumnInfo), iError =', iError
					EXIT
				END IF
				indCol = indCol + 1
				IF ( indCol > 0 ) THEN
					iLen = qtXLSGetszStringLength( ColumnInfo(indCol) % szName )
					jLen = qtXLSGetszStringLength( ColumnInfo(indCol) % TypeName )
					PRINT*,	'         ', ColumnInfo(indCol) % szName(1:iLen),	&
								ColumnInfo(indCol) % SQLDataType, ' ', 	&
								ColumnInfo(indCol) % TypeName(1:jLen),	&
								ColumnInfo(indCol) % MaxLen								
				END IF
			END DO
			DEALLOCATE(ColumnInfo)
		END DO
		DEALLOCATE(cTableNames)
	ELSE IF ( iError == qtERRORInsufficientDimension ) THEN
		IF ( iCountTableNames == 0 ) THEN
			PRINT*, 'No tables could be found.'
		ELSE
			iDIMcTableNames = iCountTableNames
			ALLOCATE (cTableNames(iDIMcTableNames))
			GOTO 100
		END IF
	ELSE
		PRINT*, '   Error (qtXLSGetTableNames), iError =', iError
	END IF

	PRINT*
	iRet = qtXLSCloseEXCELFile( hDS )
	IF ( iRet == 0 ) THEN
		PRINT*, 'qtXLS has been closed successfully.'
	ELSE
		PRINT*, 'Error, qtXLSCloseEXCELFile = ', iRet
	END IF

	PRINT*
	PRINT*, '(C) QT software GmbH, Germany. All rights reserved. 2003-2007.'
	PRINT*, '    http://www.qtsoftware.de    eMail: info@qtsoftware.de'
	PRINT*
	PAUSE 'Press Enter/Return to terminate.'
	STOP 'Program terminated.'
	
END
