#include <stdio.h>
#include <qtXLS.h>

int main(void)
{
	char *szFileName;
	qt_K_HANDLE hDS;
	const qt_K_INTEGER  SLEN = 130;
	//qt_K_INT4, PARAMETER :: iDIMcTableNames = 10;
	qt_K_INT4 iDIMcTableNames;
	char *cTableNames, *cTableNamesInd;		// -> string array with elements of length qt_I_MaxTableNameLEN
	// CHARACTER (qt_I_MaxTableNameLEN), ALLOCATABLE :: cTableNames(:)
	qt_K_INT4 iCountTableNames, iError;
	qt_K_INTEGER iRet, ind, indCol, iDIMColumnInfo, iCountColumnInfo;
	qT_ColumnInfo *ColumnInfo;

	// qtSetXLSLicencePath( szPathName )		// change the path to a location where the licence file resides

// Test "Open"
	szFileName = "qtXLSDemo1.xls";
	hDS = qtXLSOpenEXCELFile( szFileName );
	if ( hDS == 0 )	
		printf("Error, qtXLSOpenEXCELFile = %d\n", hDS);
	else
		printf("qtXLSOpenEXCELFile opens %s\n", szFileName);

	printf("\n");

// Test "Create"
	if ( hDS == 0 ) 
	{
		hDS = qtXLSCreateEXCELFile( szFileName );
		if ( hDS == 0 )
		{
			printf("Error, qtXLSCreateEXCELFile = %d\n", hDS);
			return -1;
		}
		else
			printf("qtXLSCreateEXCELFile creates %s\n", szFileName);
	}

	printf("First call to qtXLSGetTableNames to obtain the number of tables in the file.\n");
	iDIMcTableNames = 1; 	// at least one, because qtXLSGetTableNames(...) requires an existing variable cTableNames
M100:
	if ( iDIMcTableNames > 0 ) 
		cTableNames = ((char *) calloc(iDIMcTableNames, qt_I_MaxTableNameLEN));
		qtXLSGetTableNames( hDS, iDIMcTableNames, 
								  cTableNames, 
								  &iCountTableNames, 
								  &iError );
	if ( iError == qtERRORInsufficientDimension )
	{
		free(cTableNames);   // free insufficient array
      printf("   Error (qtXLSGetTableNames), iError =qtERRORInsufficientDimension\n");
		printf("   qtXLSGetTableNames(...) returns iCountTableNames = %d\n", iCountTableNames);
		if ( iCountTableNames == 0 )
			printf("No tables could be found.\n");
		else
		{ // create string array cTableNames (each element holds a string up to [qt_I_MaxTableNameLEN] characters)
			iDIMcTableNames = iCountTableNames;
			cTableNames = ((char *) calloc(iDIMcTableNames, qt_I_MaxTableNameLEN));
			goto M100;
		}
	}
	else if ( iError == 0 )
	{
		printf("   Table names:");
		for (ind = 0; ind < iCountTableNames; ind++)
		{
			cTableNamesInd = cTableNames + ind * qt_I_MaxTableNameLEN;
			printf("      %s\n", cTableNamesInd);
			// column names
			indCol = -1;
			iCountColumnInfo = 0;
			iDIMColumnInfo = 1; 	// at least one, because qtXLSGetColumnInfo(...) requires an existing variable cTableNames
			ColumnInfo = new qT_ColumnInfo[iDIMColumnInfo];
			while ( indCol < iCountColumnInfo ) 
			{
				qtXLSGetColumnInfo( hDS, 
										  cTableNamesInd, 
										  iDIMColumnInfo, 
										  ColumnInfo, 
										  &iCountColumnInfo, 
										  &iError );
				if ( iError == qtERRORInsufficientDimension )
				{
			      delete ColumnInfo;
					iDIMColumnInfo = iCountColumnInfo;
					ColumnInfo = new qT_ColumnInfo[iDIMColumnInfo];
				}
				else if ( iError != 0 )
				{
					printf("   Error (qtXLSGetColumnInfo), iError = %d\n", iError);
					break;
				}
				if ( indCol >= 0 )
				{
					printf("         %s   %d   %s   %d\n", 
								ColumnInfo[indCol].szName,
								ColumnInfo[indCol].SQLDataType, 	
								ColumnInfo[indCol].TypeName,	
								ColumnInfo[indCol].MaxLen);								
				}
				indCol = indCol + 1;
			} // while ( indCol < iCountColumnInfo ) 
			delete ColumnInfo;
		} // for (ind = 0, ind < iCountTableNames, ind++)
	} // if ( iError == 0 )
	else
			printf("   Error (qtXLSGetTableNames), iError = %d\n", iError);

	printf("\n");
	iRet = qtXLSCloseEXCELFile( hDS );
	if ( iRet == 0 )
		printf("qtXLS has been closed successfully.\n");
	else
		printf("Error, qtXLSCloseEXCELFile = %d\n", iRet);

	printf("\n");
	printf("(C) QT software GmbH, Germany. All rights reserved. 2006.\n");
	printf("    http:\\www.qtsoftware.de    eMail: info@qtsoftware.de\n");
	return 0;
}