PROGRAM qtXLSDemoListTablenames
	USE qtXLS
	IMPLICIT NONE
	CHARACTER (30) szFileName
	INTEGER (qt_K_HANDLE) hDS
	!INTEGER (qt_K_INT4), PARAMETER :: iDIMcTableNames = 10
	INTEGER (qt_K_INT4) iDIMcTableNames
	CHARACTER (qt_I_MaxTableNameLEN), ALLOCATABLE :: cTableNames(:)
	INTEGER (qt_K_INT4) iCountTableNames, iError
	INTEGER iRet, ind, iLen, jLen, indCol, iDIMColumnInfo, iCountColumnInfo
	TYPE(qT_ColumnInfo), ALLOCATABLE :: ColumnInfo(:)


   ! prior usage of any other qtXLS function either provide the licence 
   ! file ( (L0611-######.lic, supplied with ealier versions of qtXLS)
   ! or call qtSetLicence_qtXLS(). Otherwise qtXLS runs in demo mode only.)
   !
   ! (1) in case of usage of the licence file (L0611-######.lic), you 
   !     might want to set the path such that the licence file can be found
   ! CALL qtSetXLSLicencePath( szPathName )	! change the path to a location where the licence file resides
   !
   ! (2) if you prefer to have the licence linked into your program
   !     call this routine
   CALL qtSetLicence_qtXLS( iError )    ! supplied in source form (file name: qtSetLicence_0611_######.f90)

! Test "Open"
	szFileName = 'qtXLSDemo1.xls' // CHAR(0)
	hDS = qtXLSOpenEXCELFile( szFileName )
	IF ( hDS == 0 ) THEN
		PRINT*, 'Error, qtXLSOpenEXCELFile =', hDS
	ELSE
		PRINT*, 'qtXLSOpenEXCELFile opens ', szFileName
		!PRINT*, 'qtXLSOpenEXCELFile =', hDS
	END IF
	PRINT*

! Test "Create"
	IF ( hDS == 0 ) THEN
		hDS = qtXLSCreateEXCELFile( szFileName )
		IF ( hDS == 0 ) THEN
			PRINT*, 'Error, qtXLSCreateEXCELFile =', hDS
			STOP
		ELSE
			PRINT*, 'qtXLSCreateEXCELFile creates ', szFileName
			!PRINT*, 'qtXLSCreateEXCELFile =', hDS
		END IF
	END IF

	PRINT*, 'First call to qtXLSGetTableNames to obtain the number of tables in the file.'
	iDIMcTableNames = 0
100	CONTINUE
	IF ( iDIMcTableNames > 0 ) ALLOCATE (cTableNames(iDIMcTableNames), STAT=iError)
	CALL qtXLSGetTableNames( hDS, iDIMcTableNames, cTableNames, iCountTableNames, iError )
	IF ( iError == qtERRORInsufficientDimension ) THEN
		PRINT*, '   Error (qtXLSGetTableNames), iError =qtERRORInsufficientDimension'
		PRINT*, '   qtXLSGetTableNames(...) returns iCountTableNames =', iCountTableNames
		IF ( iCountTableNames == 0 ) THEN
			PRINT*, 'No tables could be found.'
		ELSE
			iDIMcTableNames = iCountTableNames
			PRINT*
			PRINT*, 'Second try...'
			GOTO 100
		END IF
	ELSE IF ( iError == 0 ) THEN
		PRINT*, '   Table names:'
		DO ind = 1, iCountTableNames
			!iLen = SCAN(cTableNames(ind), '$')
			!IF ( iLen > 0 ) THEN
			!	cTableNames(ind)(iLen:iLen) = CHAR(0)	! ersetze $
			!	iLen = iLen - 1
			!ELSE
				iLen = qtXLSGetszStringLength( cTableNames(ind) )
			!END IF
			PRINT*, '      ', cTableNames(ind)(1:iLen)
			! column names
			indCol = -1
			iCountColumnInfo = 0
			iDIMColumnInfo = 0
			DO WHILE ( indCol < iCountColumnInfo ) 
            CALL qtXLSGetColumnInfo( hDS, cTableNames(ind), iDIMColumnInfo, ColumnInfo, iCountColumnInfo, iError )
				IF ( iError == qtERRORInsufficientDimension ) THEN
					iDIMColumnInfo = iCountColumnInfo
					ALLOCATE(ColumnInfo(iDIMColumnInfo))
				ELSE IF ( iError /= 0 ) THEN
					PRINT*, '   Error (qtXLSGetColumnInfo), iError =', iError
					EXIT
				END IF
				indCol = indCol + 1
				IF ( indCol > 0 ) THEN
					iLen = qtXLSGetszStringLength( ColumnInfo(indCol) % szName )
					jLen = qtXLSGetszStringLength( ColumnInfo(indCol) % TypeName )
					PRINT*,	'         ', ColumnInfo(indCol) % szName(1:iLen),	&
								ColumnInfo(indCol) % SQLDataType, ' ',	&
								ColumnInfo(indCol) % TypeName(1:jLen),	&
								ColumnInfo(indCol) % MaxLen								
				END IF
			END DO
			DEALLOCATE(ColumnInfo)
		END DO
	ELSE
		PRINT*, '   Error (qtXLSGetTableNames), iError =', iError
	END IF

	iRet = qtXLSCloseEXCELFile( hDS )
	IF ( iRet == 0 ) THEN
		PRINT*, 'qtXLS has been closed successfully.'
	ELSE
		PRINT*, 'Error, qtXLSCloseEXCELFile = ', iRet
	END IF

	PRINT*
	PRINT*, '(C) QT software GmbH, Germany. All rights reserved. 2003-2007.'
	PRINT*, '    http://www.qtsoftware.de    eMail: info@qtsoftware.de'
	PRINT*
   PAUSE 'Press Enter/Return to terminate.'
	STOP 'Program terminated.'
END
